;------------------------------------------------------------------------------
; multi picture (art studio) viewer
; For more information on the IDE64 project,
; please see http://ide64.come.to
; or mail to: Josef.Soucek@ct.cz
;------------------------------------------------------------------------------

         *= $1000


bitmap   = $2000
end_bitmap = $3f40

atributs = $0400
end_attr = $0400+1000

colors    = $d800
end_color = $d800+1000   
             

graph_lo = $dd
graph_hi = graph_lo+1


;----------------------
second   = $ff93
tksa     = $ff96
acptr    = $ffa5
untlk    = $ffab
unlsn    = $ffae
listen   = $ffb1
talk     = $ffb4
setlfs   = $ffba
setnam   = $ffbd
open     = $ffc0
close    = $ffc3
chkin    = $ffc6
chkout   = $ffc9
chrin    = $ffcf
chrout   = $ffd2
stop     = $ffe1
getin    = $ffe4
clall    = $ffe7
udtim    = $ffea
plot     = $fff0
read     = $def4
;-------------------------



start    jsr get_name ;zadani jmena
         jsr setnam   ;nastaveni jmena pro cteni

         lda #1
         ldx $ba
         ldy #0
         jsr setlfs   ;soubor pro cteni

         jsr open     ;otevreni souboru pro cteni
         
       ;  jsr read_status
         clc 
         bcc file_open_ok
         lda #$01     ;zavreni souboru
         jsr close
         jsr clall    ;nastaveni standartni I/O
         rts          ;navrat do puvodni aplikace
         
file_open_ok
         ldx #1
         jsr chkin    ;soubor 1 je vstup
         lda #$00
         sta $90
         
         jsr chrin    ;2x bajty ven (zacatek obrazku)
         jsr chrin
         
         lda #$93     ;smazat obrazovku
         jsr chrout
         

         lda $d011
         sta buffer
         lda $d016
         sta buffer+1
         lda $d018
         sta buffer+2
         lda $d020
         sta buffer+3
         lda $d021
         sta buffer+4

         lda #$3b
         sta $d011
         lda #$d8
         sta $d016
         lda #$18
         sta $d018
         
         lda #$00
         sta $d020
         sta $d021
         
         ldx #<bitmap
         ldy #>bitmap
         stx graph_lo
         sty graph_hi
         
         lda #graph_lo
         ldx #<end_bitmap-bitmap
         ldy #>end_bitmap-bitmap
         
         jsr read
         bcc rdblk1
         


         ldy #$00
get_bitmap jsr chrin
         ldx $90
         beq file_cnt
         jmp disk_error
         
file_cnt sta (graph_lo),y
         inc graph_lo
         bne tst_end_bitmap
         inc graph_hi
         
tst_end_bitmap lda graph_lo
         cmp #<end_bitmap
         bne get_bitmap
         lda graph_hi
         cmp #>end_bitmap        ;endadress
         bne get_bitmap
         
;------------------------------------

rdblk1   ldx #<atributs
         ldy #>atributs
         stx graph_lo
         sty graph_hi
         
         lda #graph_lo
         ldx #<end_attr-atributs
         ldy #>end_attr-atributs
         jsr read
         bcc rdblk2

         
         ldy #$00
get_atributs jsr chrin
         ldx $90
         beq file_cnt1
         jmp disk_error
         
file_cnt1 sta (graph_lo),y
         inc graph_lo
         bne tst_end_atribut
         inc graph_hi
         
tst_end_atribut lda graph_lo
         cmp #<end_attr
         bne get_atributs
         lda graph_hi
         cmp #>end_attr
         bne get_atributs
         

rdblk2   ldy #$10
bytes_out jsr chrin
         dey
         bne bytes_out
         
;-------------------------------------         
         ldx #<colors
         ldy #>colors
         stx graph_lo
         sty graph_hi
         
         lda #graph_lo
         ldx #<end_color-colors
         ldy #>end_color-colors
         jsr read
         bcc rdblk3

         
         ldy #$00
get_color jsr chrin
         
file_cnt2 sta (graph_lo),y
         
         inc graph_lo
         bne tst_end_color
         inc graph_hi
         
tst_end_color lda graph_lo
         cmp #<end_color
         bne get_color
         lda graph_hi
         cmp #>end_color
         bne get_color
         
rdblk3   jsr file_close   ;uzavri soubor
         jsr press_key    ;cekani na klavesu

         
         lda buffer
         sta $d011
         lda buffer+1
         sta $d016
         lda buffer+2
         sta $d018
         lda buffer+3
         sta $d020
         lda buffer+4
         sta $d021
         clc
         rts
         

disk_error jsr file_close   ;zavri soubory
           inc $d020
         sec
         rts

         
press_key lda #$00
          sta $c6
press_key1 lda $c6
          beq press_key1
          lda #$00
          sta $c6
          rts

file_close lda #1
         jsr close
         jsr clall
         rts



;--------------------------------------------------
; routine GET FILENAME
get_name  jsr clall         ;prepnout na standartni I/O
          lda #<input_txt   ;tisk VIEW FILE
          ldy #>input_txt
          jsr $ab1e
          
          ldy #$00
rd_name   jsr chrin
          sta filename,y    ;zadani nazvu souboru
          iny
          cmp #$0d
          bne rd_name
          tya
          ldx #<filename
          ldy #>filename
          rts
          
;------------------------------------------         
; routine READ DEVICE STATUS
;------------------------------------------
read_status  lda #$00
             sta $b7    ;soubor bez jmena
             
             lda #$0f   ;soubor c.15
             ldx $ba    ;na aktualnim zarizeni
             tay
             jsr setlfs
             jsr open
             ldx #$0f
             jsr chkin  ;prepnout error kanal na vstup
             
             jsr chrin  ;cte 1. znak statusu
             asl
             asl
             asl
             asl
             sta error
             jsr chrin     ;cte 2. znak statusu
             and #%00001111
             ora error
             sta error
rdsts        jsr chrin
             cmp #$0d
             bne rdsts
             lda #$0f
             jsr close     ;zavre error kanal
             lda error
             beq no_error
             sec
             .byte $24
no_error     clc           ;otevreno bez chyby
             rts
             
error     .byte 0             

input_txt .text $0d,"VIEW FILE:",0

buffer    .byte 0,0,0,0,0     ;misto pro zalohovani dat


filename .byte 0              ;nazev 256 bajtu volno
EndPrg = filename + 256
         
         * =256*[1+EndPrg/256] ; zacatek znakovky od cele adresy
         
         
